\chapter{The classification task using a DenseNet architecture}


\begin{spacing}{1.2}
The first neural network I used for the classification task had an architecture called Dense Convolutional Network (DenseNet) (see \cite{huang2018densely}).

\section{The DenseNet Architecture}
First, I will explain the architecture. 

In a standard Convolutional Neural Network, the input image is straightforwardly passed through the network to obtain a predicted label: each convolutional layer takes in the output of the previous convolutional layer and produces an output feature map that is then passed to the next convolutional layer. In a DenseNet architecture, each layer is connected to every other layer. For each layer, the feature maps of all the preceding layers are used as inputs, and its feature map is used as input for each subsequent layer (see fig. 3.1). Whereas traditional convolutional networks with $L$ layers have $L$ connections—one between each layer and its subsequent layer this network has $\frac{L(L+1)}{2}$ direct connections.

\begin{figure}[!h]
\begin{center}
\includegraphics[width=\textwidth]{denseNet/densenet.png}
\end{center}
\caption{A deep DenseNet with three dense blocks}
\end{figure}

\section{The implementation of a custom BatchSampler}

During the training of the neural network, the training dataset is divided into batches. The batch size is the number of samples that will be passed through to the network at one time. Generally, the larger the batch size, the quicker the model will complete each epoch during training because the machine will process more than one single sample at a time. However, the size of the batch size is limited by the computational resources.

The dataset I worked on, is composed of both pathological and non-pathological patients. To ensure the network is training the right way, I had to ensure that each batch had both cases. 

So I decided to implement a custom Sampler, that will be used as a batch sampler when the dataset will be created. The batch contains at least one positive case, and it respects the proportions between the pathological and non-pathological cases. In my case, the batch size was equal to 6: each batch contains 3 pathological patients and 2 non-pathological patients.

The implementation can be found at Appendix 1. 

%\newpage

\section{The results}


\subsection*{Description of the trainer}
I trained this network on 600 epochs. An epoch means training the neural network with all the training data for one cycle: an epoch corresponds to one iteration on the whole training dataset. This training took 3.8 hours. 

In supervised learning, a machine learning algorithm builds a model by examining many examples and attempting to find a model that minimizes loss. The loss is the penalty for a bad prediction: it is a number that indicates how bad the model's prediction was on a single example. The goal is to have a loss close to zero. I decided to use the Binary Cross Entropy Loss (see eq. 3.1), which is a well-known loss for a binary classification task. 

\begin{equation}
BCELoss = - \left[ y \cdot \log x + (1 - y) \cdot \log (1 - x) \right]
\end{equation}

~\\
The initial dataset is divided into three:
\begin{itemize}
  \item \textbf{Training dataset}: The sample of data used to fit the model. In my case, it was composed of 60 patients.
  \item \textbf{Validation dataset}: The sample of data used during each epoch to ensure the model doesn't learn by heart on the testing dataset. In my case, it was composed of 20 patients.
  \item \textbf{Testing dataset}: The sample of data used to test the model in an unbiased way. In my case, it was composed of 20 patients.
\end{itemize}

\subsection*{Results}
To view the results, I displayed the confusion matrix and the ROC curve obtained on the testing dataset after 600 epochs.

I decided to use accuracy as an indicator for the performance of the classifier. The accuracy is the proportion of cases that were correctly classified (see eq. 3.2). $TP$ stands for True Positive (the positive cases that were correctly classified), $TN$ stands for True Negative (the negative cases that were correctly classified), $FP$ stands for False Positive (the positive cases that were incorrectly classified), $FN$ stands for False Negative (the negative cases that were incorrectly classified).

\begin{equation}
    accuracy = \frac{TP + TN}{TP + TN + FP + FN}
\end{equation}

The threshold used for the confusion matrix is $0.5$. With this threshold, we obtain an accuracy of 0.7 (see fig. 3.2). This accuracy seems to be great. However, the repartition of the dataset is also 0.7 as there are $\frac{2}{3}$ of pathological patients. 

\begin{figure}[!h]
\begin{center}
\includegraphics[height=8cm]{denseNet/confusion_matrix (2).png}
\end{center}
\caption{The Confusion Matrix obtained with a DenseNet network}
\end{figure}

The ROC curve (receiver operating characteristic curve) shows the trade-off between sensitivity (or $TPR$) and specificity ($1 – FPR$). Classifiers that give curves closer to the top-left corner indicate better performance (see Appendix 2). As a baseline, a random classifier is expected to give points lying along the diagonal (FPR = TPR). The higher the area under the curve is, the better the classifier is. For this experiment, the area under the ROC Curve equals 0.66 (see fig. 3.4). It is slightly better than a random classifier. The accuracy might be improved if computed with an optimal threshold.

\begin{figure}[!h]
\begin{center}
\includegraphics[height=9cm]{denseNet/roc_curve_densenet.png}
\end{center}
\caption{The ROC Curve obtained with a DenseNet network}
\end{figure}

\subsection*{A different approach}

To improve the results obtained with the DenseNet network, I decided to use a different approach. The idea is to train the network on the segmentation task, and then to do a classification task on the prediction from the segmentation task. Indeed, only two labels are specific to pathological patients (the myocardial infarction and the no-reflow area), so it should help the classification task to recognize them. 


\end{spacing}
